/* ==================================================================
                    machine enviroments setting
     NOTICE: If you want to compile in another OS written Makefile,
              please rewrite this file, and rewrite "etc.c"
               carefully with byte-order.
              (fortunately for UNIX, byte-order will be recognized
               automatically and it's unnecessary.)
   ================================================================== */
#ifndef CONFIG
	#ifndef	__STDC__
		#define	void
		#define	const
	#endif
	#ifndef __GCC__
		#define	inline
	#endif
	#if defined (Linux_i386) || defined (Solaris_UltraSPARC) || defined (FreeBSD) || defined (MacOSX) || defined (SunOS41x_SPARC)
		#define UNIXY_OS
	#endif
	/* set variable types as ...
	 *	sizeof(DWORD) = 4
	 *	sizeof(WORD)  = 2
	 *	sizeof(BYTE)  = 1
	 */
	#if defined (BCB)					/* for Borland C++ Builder */
		typedef signed long int		DWORD;
		typedef signed short		WORD;
		typedef signed char			BYTE;
		typedef unsigned long int	UDWORD;
		typedef unsigned short		UWORD;
		typedef unsigned char		UBYTE;
		#define	nativeCR			0x0D	/* Carriage return code: 0D or 0A */
		#define	ignoreCR			0x0A
			/* in case the CR+LF=0D 0A, you should use 0D for native, 0A for skip,
			   because .comment MML pick up the SPACEs code at the end of line.
			 */
	#endif
	#ifdef X68000						/* for X680x0 etc. */
		#define NOUSE68LIB				/* use libc's strlwr/stricmp */
		/* #define XCLIB */				/* use XC library */
		typedef long int		DWORD;
		typedef short			WORD;
		typedef char			BYTE;
		typedef unsigned int	UDWORD;
		typedef unsigned short	UWORD;
		typedef unsigned char	UBYTE;
		#define	nativeCR		0x0D	/* Carriage return code: 0D or 0A */
		#define	ignoreCR		0x0A
	#endif
	#ifdef MSDOS						/* for MS-DOS */
		/* Macro __TURBOC__ is automaticaly defined by compiler. */
		#if defined (__TURBOC__)			/* for Turbo-C */
			typedef signed long int		DWORD;
			typedef signed short		WORD;
			typedef signed char			BYTE;
			typedef unsigned long int	UDWORD;
			typedef unsigned short		UWORD;
			typedef unsigned char		UBYTE;
			#if !defined(fileno)
				#define fileno(f)	    ((f)->fd)
			#endif
		#else								/* for LSI-C */
			typedef long int			DWORD;
			typedef short				WORD;
			typedef char				BYTE;
			typedef unsigned long int	UDWORD;
			typedef unsigned short		UWORD;
			typedef unsigned char		UBYTE;
		#endif
		#define	nativeCR			0x0D	/* Carriage return code: 0D or 0A */
		#define	ignoreCR			0x0A
	#endif	/* MSDOS */
	#ifdef TOWNS						/* for TOWNS High-C */
		typedef signed long		DWORD;
		typedef signed short	WORD;
		typedef signed char		BYTE;
		typedef unsigned long	UDWORD;
		typedef unsigned short	UWORD;
		typedef unsigned char	UBYTE;
		#pragma On(Pointers_compatible);
		#define	nativeCR		0x0D	/* Carriage return code: 0D or 0A */
		#define	ignoreCR		0x0A
	#endif	/* TOWNS */
	#ifdef UNIXY_OS						/* for UNIX */
		typedef	long			DWORD;
		typedef	short			WORD;
		typedef	char			BYTE;
		typedef	unsigned long	UDWORD;
		typedef	unsigned short	UWORD;
		typedef	unsigned char	UBYTE;
		/* ---- Comment out if you need ---- */
		/* #define	memmove(_A, _B, _C)	bcopy(_B, _A, _C) */
		#define	nativeCR		0x0A	/* Carriage return code: 0D or 0A */
		#define	ignoreCR		0x0D
	#endif	/* UNIXY_OS */
/* ryk ==> */
	#ifdef macintosh					/* for 68K/PPC Macintosh */
		#ifdef __MWERKS__				/* with CodeWarrior */
			#define	ZMC3_STATIC_LIB		/* Make static lib */
			#define	__cdecl pascal
			#define setmode(p1, p2)
			#define main			ZMC3Main
			#define fprintf			ZMC3FormatMessage
			#define vfprintf		ZMC3FormatMessage
			#define	printf
			#define fputs(s,f)		ZMC3AddMessage(f, s)
			#define	puts(s)			ZMC3AddMessage(stderr, s)
			#define exit(c)			longjmp(g_zmc3mark, c)
			#define NOUSEMEMMOVE
			typedef	long			DWORD;
			typedef	short			WORD;
			typedef	char			BYTE;
			typedef	unsigned long	UDWORD;
			typedef	unsigned short	UWORD;
			typedef	unsigned char	UBYTE;
		#endif
		#define	nativeCR			0x0D	/* Carriage return code: 0D or 0A */
		#define	ignoreCR			0x0A
	#endif
/* <== ryk */
	#ifdef MEMDEBUG
		void memdebug(void);
		void efree(void *ptr);
		#define free(ptr) efree(ptr)
	#endif

	#define SPACE	0x20
	#define CONFIG
#endif	/* CONFIG */
