#ifndef STRUCTS2

	#include "config.h"
	#include "structs.h"

	typedef struct loopData {
		struct loopData *next;
		struct loopData *prev;
		DWORD	loopstart;	/* loop start positon */
		DWORD	loopskip;	/* whether | or |n */
		BYTE	loopmode;	/* */
		DWORD	looptime;	/* times of loop */
		DWORD	looptime2;	/* times of :| */
		DWORD	totalstart;	/* total's value at the start of loop */
		DWORD	totalmode;	/* -1=no |,|n  0= w/| 1=w/|n */
	} LOOPDATA;

	typedef struct renp {
		struct renp *next;
		struct renp *prev;
		DWORD	step;
		WORD	qvar;
		BYTE	qrelflg;
		BYTE	pflg;		/* portament? */
	} RENP;

	typedef struct {		/* [0]: var  [1]: random parameter */
		WORD	var[2];
		BYTE	relflg[2];		/* 0:abs 1:rel 2:omit -1:guardian */
	} VELOETCVAR;

	typedef struct chkstep {
		struct chkstep *next;
		struct chkstep *prev;
		UDWORD	step;		/* total's value at the start of {{...}} */
	} CHKSTEP;

	typedef struct chkchord {
		struct chkchord *next;
		struct chkchord *prev;
		DWORD	gatepos;
		DWORD	gate;
		DWORD	step;			/* add v0.95 */
		DWORD	delay;			/* add v0.95 */
		BYTE	note;			/* note number which is using on the chord */
		BYTE	renputieflg;	/* last tied chord in the tuplet */
		BYTE	isclosed;		/* Is this tone handled with? */
	} CHKCHORD;

	typedef struct linedata {
		struct	linedata	*next;
		char	*filename;
		DWORD	line;
	} LINEDATA;

	typedef struct linefiledata {
		struct	linefiledata	*next;
		char	*filename;
	} LINEFILEDATA;



	typedef struct back {
		struct back *next;
		struct back *prev;
	} BACK;
	#define	BACKEVENT	0;

/*
	typedef struct event {
		struct back *next;
		struct back *prev;
		int code;
	} EVENT;
*/

	typedef struct {
		BYTE		noteon;
		BYTE		setdev;			/* ==0 until @i will be set */
		BYTE		ksign[12];
		BYTE		instid[3];		/* eg. 0x41 0x10 0x42 */
		BYTE		octave;
		BYTE		bendrange;
		DWORD		total;
		DWORD		total_indoloop;	/* add v0.96 */
		UWORD		Step;
		UWORD		laststep;
		VELOETCVAR	velou,*velocity,*quantize,mod[17],arcc[17];
		UWORD		gtreso;			/* quantize_resolution */
/*
		LOOPDATA	l[9];
		LOOPDATA	d[9];
*/
		BYTE		lpos,dpos;
		/*UBYTE		velou[2];*/
		UBYTE		volmode;
		WORD		relvelo;		/* +127 - -128 */
		UBYTE		nowvelo;
		BYTE		veloseqsw;
		BYTE		velozpos,quantizepos,modpos,arccpos;
		BYTE		veloznum,quantizenum,modnum,arccnum;			/* 0:none */

		WORD		veloofst, volofst, arccofst[4];

		/* BYTE		vol; */
		BYTE		randvelotype;
		UWORD		randvelopower;
		BYTE		relvol;
		BYTE		relpan;
		BYTE		transpose;
		WORD		abdelay;			/* auto bend delay */
		WORD		pdelay;				/* portament delay */
		WORD		cdelay;				/* chord delay */
		WORD		ptime;				/* portament time */
		BYTE		fadeout;
		BYTE		spvelomode;
		DWORD		renpnotes;

		UBYTE		autopan[128];
		BYTE		autopansw;

		DWORD		segno;
		DWORD		coda;

		BYTE		bankh;
		BYTE		bankl;

		BYTE		back_repeat;

		UWORD		echoitv;			/* for the MML "echo" */
		WORD		echodec;
		UWORD		echolp;

		LOOPDATA	*l;
		LOOPDATA	*d;					/* only "looptime" is used */
		RENP		*r;
		CHKSTEP		*s;
		BACK		*b;
/*		EVENT		*e;*/
		CHKCHORD	*c;

		COMMONINF *cominf;
	} TRKINF;


	typedef struct {
		UWORD	hash;
		UBYTE	pc;
		BYTE	msb;
		BYTE	lsb;
		char	*progname;
	} PROGHASH;

	#define STRUCTS2
#endif
