#include "config.h"

#define	FILENOTFOUND	1
#define	NONZMD			2
#define	ZMDVERERR		3
#define	READERR			4
#define	WRITEERR		5
#define	FLUSHERR		6
#define	SWERR			7
#define	TOOMANYFILES	8
#define	WAVNOTDEFIND	9
#define	NOMEMORY		10
#define	ILLEGALSWITCH	11
#define	ILLEGALMEMORY	12
#define	COMPILEERROR	13


/* #ifdef MEMDEBUG */
typedef struct memDebugData {
	struct memDebugData *next;
	/* struct memDebugData *prev; */
	DWORD	size;		/* malloced size */
	void	*adrs;		/* malloced area */
	char	*label;		/* label name */
} MEMDEBUGDATA;

void memdebug(void);
/* #endif */
void initMemMaster(void);

void efreeAll(void);
void efreeAll2(char *label);
void efree(void *ptr, char *label);
void *emalloc(size_t n, char *label);
void *erealloc(void *ptr,size_t n, char *label);
void *emarealloc(void *ptr,size_t n, char *label);
void fatal(int ret,char *fmt, ...);
void terminateProgram(int);
inline WORD  getWordAlign(UBYTE*);
inline DWORD getDwordAlign(UBYTE*);
inline void  putWordAlign(UBYTE*,WORD);
inline void  putDwordAlign(UBYTE*,DWORD);
inline WORD  getWord(UBYTE*);
inline DWORD getDword(UBYTE*);
inline void  putWord(UBYTE*,WORD);
inline void  putDword(UBYTE*,DWORD);
#ifndef UNIXY_OS
int iskanji(int a);
#endif

/* ryk ==> */
#ifdef ZMC3_STATIC_LIB	/* Shared lib */
#define	MAXERRMSG		16384
void ZMC3CreateMessageBuf(void);
char* ZMC3GetMessageBuf(void);
void ZMC3DisposeMessageBuf(void);
#endif
void ZMC3FormatMessage(FILE*, const char*, ...);
void ZMC3AddMessage(FILE*, const char* pmsg);
/* <== ryk */
